unit VaxCallPickUp;

interface
uses

    System.Classes,
    SysUtils,
    VaxCallSessionRoute,
    VaxDefine,
    VaxTeleServerSIP,
    VaxServerCOM,
    VaxServerExCOM;

type TVaxCallPickUp = class

  public
        m_objVaxServer : TVaxTeleServerSIP;

    private

      function IsPickUpCall(sDialNo : string): boolean;
      function PickUpCall(nSessionId : integer; sDialNo : string): boolean;

    public

      constructor Create(); reintroduce; overload;
      function OnIncomingCall(nSessionId: Integer; sDialNo: String; nFromPeerType: Integer; sFromPeerName: String) : Boolean;

end;


implementation

      constructor TVaxCallPickUp.Create();
      begin

      end;

      function TVaxCallPickUp.IsPickUpCall(sDialNo : string): boolean;
      begin

        if(AnsiPos('#5#', sDialNo) <> 1) Then
        begin
          // #5# Not found
          Exit(false);
        end;

        Result := True;

      end;

      function TVaxCallPickUp.PickUpCall(nSessionId : integer; sDialNo : string): boolean;
      begin

        sDialNo := StringReplace(sDialNo, '#5#', '', [rfReplaceAll, rfIgnoreCase]);
        Trim(sDialNo);

        Result := TVaxServerExCOM.mVaxExCOM.PickUpCall(nSessionId, sDialNo);

      end;

      function TVaxCallPickUp.OnIncomingCall(nSessionId: Integer; sDialNo: String; nFromPeerType: Integer; sFromPeerName: String) : Boolean;
      var
        sPickUpGroupName : string;
      begin

        if(nFromPeerType <> TVaxServerCOM.VAX_PEER_TYPE_USER) Then
          Exit(False);

        if(IsPickUpCall(sDialNo) = False) Then
          Exit(False);

        if(PickUpCall(nSessionId, sDialNo) = False) Then
          Exit(False);

        Result := True;

      end;

end.
