﻿Public Class CallPickUpForm

    Private m_objVaxTeleSIP As cVaxServerSIP
    Public m_nProcessType As Integer

    Public Sub New(ByRef objVaxTeleSIP As cVaxServerSIP)

        InitializeComponent()
        m_objVaxTeleSIP = objVaxTeleSIP

    End Sub

    Private Sub BtnAddCallPickUpGroup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddCallPickUpGroup.Click

        If (comboPickupGroup.Text = "") Then
            MessageBox.Show("Please Enter Pickup Group Name")
        End If

        If comboPickupGroup.FindStringExact(comboPickupGroup.Text) <> -1 Then
            If (MessageBox.Show("PickUp Group already exist, do you want to continue?", "VaxTeleSIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = DialogResult.No) Then
                Exit Sub
            End If
        End If

        If (comboPickupGroup.Items.Contains(comboPickupGroup.Text)) Then
            m_objVaxTeleSIP.RemoveCallPickUpGroup(comboPickupGroup.Text.Trim())
        End If

        If (Not m_objVaxTeleSIP.AddCallPickUpGroup(comboPickupGroup.Text)) Then
            MessageBox.Show("Pickup Group couldn't be added.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        For Each sMemeberName As String In ListBoxMember.Items
            m_objVaxTeleSIP.AddCallPickUpGroupMember(comboPickupGroup.Text, sMemeberName)
        Next

        If (Not comboPickupGroup.Items.Contains(comboPickupGroup.Text)) Then
            comboPickupGroup.Items.Add(comboPickupGroup.Text)
        End If

        MessageBox.Show("PickUp Group added/updated successfully.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnRemoveCallPickUpGroup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveCallPickUpGroup.Click

        If (comboPickupGroup.Text = "" Or (Not comboPickupGroup.Items.Contains(comboPickupGroup.Text))) Then
            Return
        End If

        Dim nIndex As Integer = comboPickupGroup.FindStringExact(comboPickupGroup.Text)
        If (nIndex = -1) Then Return

        m_objVaxTeleSIP.RemoveCallPickUpGroup(comboPickupGroup.Text)
        comboPickupGroup.Items.RemoveAt(nIndex)

        ClearDlgContent()

        If (comboPickupGroup.Items.Count > 0) Then
            comboPickupGroup.SelectedIndex = 0
        End If

        ShowPickupGroupDetails()

        MessageBox.Show("PickUp Group removed successfully.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnClearCallPickUpGroup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearCallPickUpGroup.Click

        comboPickupGroup.Text = ""
        comboAgentName.Text = ""

        ListBoxMember.Items.Clear()

    End Sub

    Private Sub BtnAddCallPickUpMember_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddCallPickUpMember.Click

        If ListBoxMember.FindStringExact(comboAgentName.Text) <> -1 Then
            MessageBox.Show("Login already exists.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ListBoxMember.Items.Add(comboAgentName.Text)

    End Sub

    Private Sub BtnRemoveRingCallPickUpMember_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveRingCallPickUpMember.Click
        ListBoxMember.Items.Remove(ListBoxMember.SelectedItem)
    End Sub

    Private Sub BtnClearCallPickUpMember_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearCallPickUpMember.Click
        ListBoxMember.Items.Clear()
    End Sub

    Private Sub ClearDlgContent()

        comboPickupGroup.Text = ""
        ListBoxMember.Items.Clear()

    End Sub

    Private Sub AddUsers()

        comboAgentName.Items.Clear()

        Dim objUserList As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetUserNameAll(objUserList)

        If (objUserList.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objUserList.Count - 1
            comboAgentName.Items.Add(objUserList.Item(nIndex))
        Next

        If (comboAgentName.Items.Count > 0) Then
            comboAgentName.SelectedIndex = 0
        End If

    End Sub

    Private Sub AddPickUpGroups()

        comboPickupGroup.Items.Clear()

        Dim objListPickUpName As List(Of String) = New List(Of String)
        m_objVaxTeleSIP.GetPickUpGroupNameAll(objListPickUpName)

        If (objListPickUpName.Count <= 0) Then
            Return
        End If

        For Each sPickUpGroupName In objListPickUpName
            comboPickupGroup.Items.Add(sPickUpGroupName)
        Next

        If (comboPickupGroup.Items.Count > 0) Then
            comboPickupGroup.SelectedIndex = 0
        End If

    End Sub

    Public Sub OnSetActive()

        AddUsers()
        AddPickUpGroups()

        ShowPickupGroupDetails()

    End Sub

    Private Sub comboPickupGroupSelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboPickupGroup.SelectedIndexChanged

        ShowPickupGroupDetails()

    End Sub

    Private Sub ShowPickupGroupDetails()

        Dim sPickUpGroupName As String = comboPickupGroup.Text

        If (sPickUpGroupName.Length = 0) Then
            Return
        End If

        ListBoxMember.Items.Clear()

        Dim objListCallPickUpMember As List(Of String) = New List(Of String)

        If (Not m_objVaxTeleSIP.GetPickUpMemberNameAll(sPickUpGroupName, objListCallPickUpMember)) Then Return

        For Each sMemberName In objListCallPickUpMember
            ListBoxMember.Items.Add(sMemberName)
        Next

    End Sub

End Class