﻿Public Class cCallPickUpDetails

    Public m_sCallPickUpGroup As String
    Dim m_objMemberList As cCallPickUpMemberList

    Public Sub New(ByVal sPickUpGroupName As String)

        m_sCallPickUpGroup = sPickUpGroupName
        m_objMemberList = New cCallPickUpMemberList()

    End Sub

    Public Function AddCallPickUpGroupMember(ByVal sMemberName As String) As Boolean

        Return m_objMemberList.AddMember(sMemberName)

    End Function

    Public Sub RemoveCallPickUpGroupMember(ByVal sMemberName As String)

        m_objMemberList.RemoveMember(sMemberName)

    End Sub

    Public Function GetPickUpMemberList(ByRef objListMemberName As List(Of String)) As Boolean

        Return m_objMemberList.GetMemberList(objListMemberName)

    End Function

    Public Function IsGroupMember(ByVal sMemberName) As Boolean

        Return m_objMemberList.IsGroupMember(sMemberName)

    End Function

    Public Sub DeleteAllPickUpMember()

        m_objMemberList.DeleteAllPickUpMember()

    End Sub

End Class

'/////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////

Public Class cCallPickUpList

    Dim m_objCallPickUpList As New Dictionary(Of String, cCallPickUpDetails)

    Public Sub New()

    End Sub

    Public Function AddCallPickUpGroup(ByVal sGroupName As String) As Boolean

        Dim objDetails As cCallPickUpDetails = Nothing

        m_objCallPickUpList.TryGetValue(sGroupName, objDetails)

        If (objDetails Is Nothing) Then

            objDetails = New cCallPickUpDetails(sGroupName)
            m_objCallPickUpList.Add(sGroupName, objDetails)

        End If

        Return True

    End Function

    Public Sub RemoveCallPickUpGroup(ByVal sGroupName As String)

        Dim objDetails As cCallPickUpDetails = Nothing

        m_objCallPickUpList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return

        m_objCallPickUpList.Remove(sGroupName)

    End Sub

    Public Function AddCallPickUpGroupMember(ByVal sGroupName As String, ByVal sMemberName As String) As Boolean

        Dim objDetails As cCallPickUpDetails = Nothing

        m_objCallPickUpList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return False

        Return objDetails.AddCallPickUpGroupMember(sMemberName)

    End Function

    Public Sub RemoveCallPickUpGroupMember(ByVal sGroupName As String, ByVal sMemberName As String)

        Dim objDetails As cCallPickUpDetails = Nothing

        m_objCallPickUpList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return

        objDetails.RemoveCallPickUpGroupMember(sMemberName)

    End Sub

    Public Function GetPickUpDetails(ByVal sGroupName As String, ByRef objListUserName As List(Of String)) As Boolean

        Dim objDetails As cCallPickUpDetails = Nothing

        m_objCallPickUpList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return False

        Return objDetails.GetPickUpMemberList(objListUserName)

    End Function

    Public Function FindCallPickUp(ByVal sGroupName As String) As cCallPickUpDetails

        Dim objDetails As cCallPickUpDetails = Nothing

        m_objCallPickUpList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return Nothing

        Return objDetails

    End Function

    Public Function GetAllPickUpGroupName(ByRef sListPickUpName As List(Of String)) As Boolean

        Dim objDetails As cCallPickUpDetails = Nothing

        For Each sCallPickUpGrouAgentpName As KeyValuePair(Of String, cCallPickUpDetails) In m_objCallPickUpList

            objDetails = sCallPickUpGrouAgentpName.Value
            sListPickUpName.Add(objDetails.m_sCallPickUpGroup)

        Next

        Return True

    End Function

    Public Function GetPickUpMemberName(ByVal sGroupName As String, ByRef objListMemberName As List(Of String)) As Boolean

        Dim objDetails As cCallPickUpDetails = Nothing

        m_objCallPickUpList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return False

        Return objDetails.GetPickUpMemberList(objListMemberName)

    End Function

    Public Function IsGroupMember(ByVal sGroupName As String, ByVal sMemberName As String) As Boolean

        Dim objDetails As cCallPickUpDetails = Nothing

        m_objCallPickUpList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return False

        Return objDetails.IsGroupMember(sMemberName)

    End Function

    Public Sub DeletePickUpGroupAll()

        For Each objPickUpDetails As cCallPickUpDetails In m_objCallPickUpList.Values
            objPickUpDetails.DeleteAllPickUpMember()
        Next

    End Sub

End Class
