
Imports ServerSIP.VBNetSIPServerSample

Public Class GeneralForm

    Dim m_objUsageCPU As PerformanceCounter = New PerformanceCounter("Processor", "% Processor Time", "_Total")
    Private m_objVaxTeleSIP As cVaxServerSIP

    Public Sub New(ByRef objVaxTeleSIP As cVaxServerSIP)

        InitializeComponent()
        m_objVaxTeleSIP = objVaxTeleSIP

    End Sub


    Private Sub GeneralForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim sSIPListenIP As String = ""
        Dim nSIPListenPort As Integer = 5060

        If (m_objVaxTeleSIP.GetInitialize(sSIPListenIP, nSIPListenPort) = False) Then
            sSIPListenIP = ""
            nSIPListenPort = 5060
        End If

        EditListenIP.Text = sSIPListenIP
        EditListenPort.Text = nSIPListenPort.ToString()

        EditPlayWaveDialTone.Text = m_objVaxTeleSIP.GetMusicDialTone()
        EditPlayWaveHold.Text = m_objVaxTeleSIP.GetMusicHold()

        UpdateStats()
        TimerGeneral.Enabled = True

    End Sub

    Private Sub BtnStartServerSIP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnStartServerSIP.Click

        m_objVaxTeleSIP.SetLicenseKey("TRIAL-LICENSE-KEY")

        Dim bStatusRun As Boolean = m_objVaxTeleSIP.Initialize(EditListenIP.Text, EditListenIP.Text, Convert.ToInt32(EditListenPort.Text))

        If (Not bStatusRun) Then
            LabelServerStatus.Text = "UNABLE TO START SIP SERVER (SEE ERROR LOG)."
            Return
        End If

        LabelServerStatus.Text = "SIP SERVER IS RUNNING."

        m_objVaxTeleSIP.LoadMusicHold(EditPlayWaveHold.Text.Trim())
        m_objVaxTeleSIP.LoadMusicDialTone(EditPlayWaveDialTone.Text.Trim())

        m_objVaxTeleSIP.VoiceSessionLost(True, 20) 'Enable voice session lost for 20 seconds.
        m_objVaxTeleSIP.VideoCOMM(True)            'Enable Video Communication.

        TimerGeneral.Enabled = True

    End Sub

    Private Sub BtnStopServerSIP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnStopServerSIP.Click

        m_objVaxTeleSIP.UnInitialize()

        LabelServerStatus.Text = "SIP SERVER IS NOT RUNNING."
        TimerGeneral.Enabled = False

    End Sub

    Private Sub TimerGeneral_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerGeneral.Tick
        UpdateStats()
    End Sub

    Public Sub UpdateStats()

        LabelTotalCalls.Text = m_objVaxTeleSIP.GetCallCount().ToString()
        LabelTotalUsers.Text = m_objVaxTeleSIP.GetRegisteredUserCount().ToString()

        LabelUsageCPU.Text = GetUsageCPU().ToString()
        LabelUsageMEM.Text = GetAvailableMEM().ToString()

    End Sub

    Public Function GetAvailableMEM() As Long
        Dim objUsageMEM As PerformanceCounter = New PerformanceCounter("Memory", "Available KBytes")
        Return Convert.ToInt32(objUsageMEM.NextValue())
    End Function

    Public Function GetUsageCPU() As Long
        Return Convert.ToInt32(m_objUsageCPU.NextValue())
    End Function

    Public Sub OnSetActive()

    End Sub

End Class
