#include "stdafx.h"
#include "ConfRoom.h"
#include "VaxServerExCOM.h"

CConfRoom::CConfRoom(CVaxServerExCOM* pServerExCOM)
{
	m_pServerExCOM = pServerExCOM;

	m_pConfRoomList = new CConfRoomList(pServerExCOM);
}

CConfRoom::~CConfRoom()
{
	delete m_pConfRoomList;
}

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

BOOL CConfRoom::AddRoom(LPCTSTR sRoomName, LPCTSTR sRoomNo)
{
	if(!m_pConfRoomList->AddRoom(sRoomName, sRoomNo))
		return FALSE;
	
	if(!m_pServerExCOM->OpenConferenceRoom(sRoomName))
	{
		m_pConfRoomList->RemoveRoom(sRoomName);
		return FALSE;
	}
	
	return TRUE;
}

void CConfRoom::RemoveRoom(LPCTSTR sRoomName)
{
	m_pServerExCOM->CloseConferenceRoom(sRoomName);
	m_pConfRoomList->RemoveRoom(sRoomName);
}

BOOL CConfRoom::GetRoomDetails(LPCTSTR sRoomName, CString& sRoomNo)
{
	return m_pConfRoomList->GetRoomDetails(sRoomName, sRoomNo);
}

BOOL CConfRoom::IsRoomNoExists(LPCTSTR sRoomNo)
{
	return m_pConfRoomList->IsRoomNoExists(sRoomNo);
}

BOOL CConfRoom::GetRoomAll(CStringList* pRoomList)
{
	return m_pConfRoomList->GetRoomAll(pRoomList);
}

CString CConfRoom::GetRoomName(LPCTSTR sRoomNo)
{
	return m_pConfRoomList->GetRoomName(sRoomNo);
}

void CConfRoom::DeleteRoomAll()
{
	m_pConfRoomList->DeleteRoomAll();
}



